//+------------------------------------------------------------------+
//|                                          market order ecnv12.mq4 |
//|                                                                  |
//|                                                  http://www..com |
//+------------------------------------------------------------------+


#property copyright ""
//-----------------------------------------------------------------------------+
// External Variables
extern bool   DynamicLotSize = false;
extern double EquityPercent  =   1;
extern double FixedLotSize   = 0.01;
extern double Multiplier     =   2;
extern double LotDigits      =   2;
extern double StopLoss       =  50;
extern double TakeProfit     =  20;
extern double TrailingStop   =   2;
extern int    MinimumProfit  =   3;
extern int    Slippage       =   3;
extern double OpenDistance   =   2;
extern double ReturnDist     =   1;
extern double MinStop        =   1;
extern int    MagicNumber    = 08012013;

//-----------------------------------------------------------------------------+
// Global Variables
int BuyTicket,SellTicket, RealSlippage,total;
double pt;
double volume_previous = 0;
//-----------------------------------------------------------------------------+
int init ()// Adjust for 4 or 5 digits.
   {
   if (Digits == 2 || Digits == 4) 
      {
      pt = Point;
      RealSlippage = Slippage;
      }    
   if (Digits == 3 || Digits == 5) 
      {
      pt = Point * 10;
      RealSlippage = Slippage * 10;
      }    
  return(0);   
 }
 
//+---------------------------------------------------------------------------+
int start()// A line is used to get orders opening above or under this line more or minus OpenDistance. The reason of the line is that don't know how to use datetime to get it.
 {//0 
   
  
  //+---------------------------------------------------------------------------+	         		
  // Lot size calculation
  // Here I put limits to lot size in terms if wich equity I want to negociate(%). 
  //Also The lot size is dependant of the StopLoss.

   if(DynamicLotSize == true)
      {//1
      double RiskAmount = AccountEquity() * (EquityPercent / 100);
      double TickValue = MarketInfo(Symbol(),MODE_TICKVALUE);
           
      if(Point == 0.001 || Point == 0.00001) TickValue *= 10;
      double LotSize = (RiskAmount / StopLoss) / TickValue;
      }//1
   else LotSize = FixedLotSize;
          
  //+---------------------------------------------------------------------------+     
  // Lot size verification. Here the minimum and max lot size is verified and LotStep.

  if(LotSize < MarketInfo(Symbol(),MODE_MINLOT))
     {//2
     LotSize = MarketInfo(Symbol(),MODE_MINLOT);
     }//2
  else if(LotSize > MarketInfo(Symbol(),MODE_MAXLOT))
     {//3
     LotSize = MarketInfo(Symbol(),MODE_MAXLOT);
     }//3
     	
  if(MarketInfo(Symbol(),MODE_LOTSTEP) == 0.1)
     {//4
     LotSize = NormalizeDouble(LotSize,1);
     }//4
  else LotSize = LotSize;	
   	
 //+----------------------------------------------------------------------------+		
 
 
 
 
 
 
  // Buy Order Condition to Open

  if(Volume[0] > volume_previous + OpenDistance*pt && BuyTicket == 0)                       
	  {//5	
	  while(IsTradeContextBusy()) Sleep(10);
	  RefreshRates();	
		       
     BuyTicket=OrderSend(Symbol(),OP_BUY,LotSize,Ask,RealSlippage,0,0,"Buy Order",MagicNumber,0,Green);
     if(BuyTicket > -1)
        {//6
         Print("Opposite Buy order placed # ",BuyTicket);
         AddLimitsBuy();        
         }//6
      else
         {//7 
         Print("Order Send failed, error # ", GetLastError());
         }//7 
         
      return(0);
      }//5
  //-----------------------------------------------------------------------------+	
  
  // Sell Order Condition to Open

  if(Volume[0] < volume_previous - OpenDistance*pt && SellTicket == 0)                   
     {//8                                 
	  while(IsTradeContextBusy()) Sleep(10);
	  RefreshRates();	
				 		
	  SellTicket=OrderSend(Symbol(),OP_SELL,LotSize,Bid,RealSlippage,0,0,"Sell Order",MagicNumber,0,Red);
	  if(SellTicket > -1)
 		  {//9
        Print("Opposite Sell order placed # ", SellTicket);
        AddLimitsSell();       
        }//9
     else
        {//10
        Print("Order Send failed, error # ", GetLastError());
        }//10      
     return(0);
     }//8				 				
   //+---------------------------------------------------------------------------+  
   //Last Order Loss Compensation (increase size of last lot if not in profit)

   double LastProfit,LastLot,MLots;
    
   for(int i = 0; i < OrdersTotal(); i++)
       {//11
       if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
          {//12
          if(OrderSymbol() == Symbol()&& OrderMagicNumber() == MagicNumber)
             {//13
              LastProfit = OrderProfit();
              LastLot = OrderLots();
             }//13 
             
          MLots = 0;              
          if (LastProfit < 0) MLots = LastLot * Multiplier;
          }//12
       else MLots = LotSize;
       }//11       
//+------------------------------------------------------------------+ 
//Open Opposite Order (open opposite order if last order not reach TakeProfit)
//Here extra code was introduced to limit multiple orders. Ticket--> BuyTicket and SellTicket
 
   int Op;  
   
   for(int Counter = OrdersTotal()-1; Counter >= 0; Counter--)
      {//14
      if(OrderSelect(Counter,SELECT_BY_POS,MODE_TRADES))  
         {//15
         if(OrderSymbol() == Symbol()&& OrderMagicNumber() == MagicNumber)
            {//16
            Op = OrderType();

            if(Op == OP_BUY && Bid < OrderOpenPrice() - (ReturnDist*pt) && SellTicket == 0)
               {//17               
               SellTicket = OrderSend(Symbol(), OP_SELL, MLots, Bid, RealSlippage, 0, 0, "Sell Order", MagicNumber, 0, Red);
               if(SellTicket > -1) 
                  {//18
                  Print("Opposite Sell order placed # ", SellTicket);
                  AddLimitsSell();
                  }//18
               else
                  {//19
                  Print("Order Send failed, error # ", GetLastError() );
                  }//19
                }//17
                           
            if(Op == OP_SELL && Ask > OrderOpenPrice() + (ReturnDist*pt)&& BuyTicket == 0)
               {//20             
               BuyTicket = OrderSend(Symbol(), OP_BUY, MLots, Ask, RealSlippage, 0, 0, "Buy Order", MagicNumber, 0, Green);
               if(BuyTicket > -1)
                  {//21
                  Print("Opposite Buy order placed # ", BuyTicket);
                  AddLimitsBuy();
                  }//21
               else
                  {//22  
                  Print("Order Send failed, error # ", GetLastError());
                  }//22   
               }//20
            }//16
         }//15    
      }//14
           
   //+------------------------------------------------------------------+  
   //Trailing Stop. Here the Minimum Profit TrailingStop will start when order profit reach a minimum profit
   // above or under the orderOpenPrice.In this case when MinimumProfit is 5 pips TrailingStop goes to 3 pips after the OrderOpenPrice.

   if(TrailingStop > 0)         
      for(int OrderCounter = 0; OrderCounter < OrdersTotal(); OrderCounter++)
         {//23
         OrderSelect(OrderCounter,SELECT_BY_POS,MODE_TRADES);
         if(OrderType()==OP_BUY && OrderSymbol()== Symbol() 
            && OrderMagicNumber()== MagicNumber)
            {//24
            if(OrderStopLoss() < MarketInfo(Symbol(),MODE_BID) - TrailingStop*pt && MarketInfo(Symbol(),MODE_BID) - OrderOpenPrice() >= MinimumProfit*pt)    
               {//25
               OrderModify(OrderTicket(),OrderOpenPrice(),MarketInfo(Symbol(),MODE_BID) - TrailingStop*pt,OrderTakeProfit(),0,Yellow);  
               }//25
             }//24
           }//23          
           if(OrderType()==OP_SELL && OrderSymbol()== Symbol() 
              && OrderMagicNumber()== MagicNumber)
              {//26
              if(OrderStopLoss() > MarketInfo(Symbol(),MODE_ASK) + TrailingStop*pt && OrderOpenPrice() - MarketInfo(Symbol(),MODE_ASK) >= MinimumProfit*pt)
                 {//27
                  OrderModify(OrderTicket(),OrderOpenPrice(),MarketInfo(Symbol(),MODE_ASK) + TrailingStop*pt,OrderTakeProfit(),0,Yellow);
                 }//27
              return(0);     
              }//26       
   //+------------------------------------------------------------------+  

   // Close All(close all open positions if last one reach TakeProfit) 
   //Here I don't know how to close all opened orders when TrailingStop closes the order. Think that orderProfit() > 0 is not the righ way...

   int OrdType, GLError;
   double OrderClosed;
   RefreshRates();
   for(int Closed = 0; Closed < OrdersTotal()-1; Closed++)
   //for(int Closed = OrdersTotal()-1;Closed >= 0; Closed--) 
      if(OrderSelect(Closed,SELECT_BY_POS,MODE_HISTORY)==true
        && OrderMagicNumber()== MagicNumber
        && OrderSymbol()== Symbol())
        {//29
        OrderClosed = OrderCloseTime();
        if(OrderClosed!=0)
           {//30                                  
   for(int OrderPos = OrdersTotal()-1; OrderPos >= 0; OrderPos--)       
      if(OrderSelect(OrderPos, SELECT_BY_POS, MODE_TRADES)
         && OrderMagicNumber()== MagicNumber 
         && OrderSymbol()== Symbol())                                       
         {//31
         OrdType = OrderType();
         if(OrdType == OP_BUY || OrdType==OP_SELL)
           {//32
           if(!OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(),RealSlippage, Yellow))
               GLError = GetLastError();
           }//32
                      
          if(!ObjectsDeleteAll())
              GLError = GetLastError();
          }//31
       }//30
     }//29 
    
  if(GLError > 0) Print("Error Closing/Deleting Order, error # ", GLError, " for ticket: ", OrderTicket());           
  return(0);
  }//0 
                       
  //+------------------------------------------------------------------+
  //Add limits after sent order for ECN Brokers)    This block besides to add the order limits it wil look to put the limits outside the Freeze zone

   void  AddLimitsBuy()
      {
      OrderSelect(BuyTicket,SELECT_BY_TICKET);
      double OpenPrice = OrderOpenPrice();

      double StopLevel = MarketInfo(Symbol(),MODE_STOPLEVEL)*Point;
      RefreshRates();	
      double UpperStopLevel = Ask + StopLevel;
      double LowerStopLevel = Bid - StopLevel;
				       				      
      if(StopLoss > 0) 
        double BuyStopLoss  = OpenPrice - (StopLoss * pt);
      
      if(TakeProfit > 0) 
        double BuyTakeProfit = OpenPrice + (TakeProfit * pt);
				      
      if(BuyStopLoss > 0 && BuyStopLoss > LowerStopLevel) 
	     {					
	  	  BuyStopLoss = LowerStopLevel - (MinStop*pt);
		  }
				      
	   if(BuyTakeProfit > 0 && BuyTakeProfit < UpperStopLevel) 
	     {
	     BuyTakeProfit = UpperStopLevel + (MinStop*pt);
	     }

	   if(IsTradeContextBusy())
	      Sleep(10);	

     if(BuyStopLoss > 0 || BuyTakeProfit > 0) 
        {		
        OrderModify(BuyTicket,OpenPrice,BuyStopLoss,BuyTakeProfit,0);                            
        }
     } 
   //+------------------------------------------------------------------+
   //Add limits after sent order (ECN Brokers)     This block besides to add the order limits it wil look to put the limits outside the Freeze zone

   void   AddLimitsSell()
      {
      OrderSelect(SellTicket,SELECT_BY_TICKET);
      double OpenPrice = OrderOpenPrice(); 
                 
      double StopLevel = MarketInfo(Symbol(),MODE_STOPLEVEL)*Point;
	   RefreshRates();	
	   double UpperStopLevel = Ask + StopLevel;
	   double LowerStopLevel = Bid - StopLevel;
				      				      
	   if(StopLoss > 0) 
	     double SellStopLoss = OpenPrice + (StopLoss * pt);
	   
      if(TakeProfit > 0) 
        double SellTakeProfit = OpenPrice - (TakeProfit * pt);
				      
	   if(SellStopLoss > 0 && SellStopLoss < UpperStopLevel) 
	     {					
		  SellStopLoss = UpperStopLevel + (MinStop*pt);
		  }
		
	   if(SellTakeProfit > 0 && SellTakeProfit > LowerStopLevel) 
		  {
	     SellTakeProfit = LowerStopLevel - (MinStop*pt);
		  }
					      
	   if(IsTradeContextBusy()) 
	     Sleep(10);	

      if(SellStopLoss > 0 || SellTakeProfit > 0) 
         {		
         OrderModify(SellTicket,OpenPrice,SellStopLoss,SellTakeProfit,0);
         }                    
     }
//+------------------------------------------------------------------+     
         
       


